Index: modules/Froogle/froogle.php
--- modules/Froogle/froogle.php	2011-08-25 16:19:10.000000000 +0400
+++ modules/Froogle/froogle.php	2011-08-25 16:11:28.000000000 +0400
@@ -115,7 +115,44 @@
         // Full header:
         // title\tdescription\tlink\timage_link\tid\texpiration_date\tlabel\tprice\tprice_type\tcurrency\tpayment_accepted\tpayment_notes\tquantity\tbrand\tupc\tisbn\tmemory\tprocessor_speed\tmodel_number\tsize\tweight\tcondition\tcolor\tactor\tartist\tauthor\tformat\tproduct_type\tlocation
 
-        fputs($fp, "title\tdescription\tlink\timage_link\tid\tprice\tcurrency\tpayment_accepted\tpayment_notes\tquantity\tweight\texpiration_date\tbrand\tcondition\tproduct_type\n");
+        # Default header
+        #fputs($fp, "title\tdescription\tlink\timage_link\tid\tprice\tcurrency\tpayment_accepted\tpayment_notes\tquantity\tweight\texpiration_date\tbrand\tcondition\tproduct_type\n");
+
+        $additional_attributes = array();
+
+        if(!empty($active_modules["Extra_Fields"])) {
+            $default_additional_attributes = array(
+                "gtin" => "gtin",
+                "mpn" => "mpn",
+                "upc" => "upc",
+                "ean" => "ean",
+                "jan" => "jan",
+                "isbn" => "isbn",
+                "c:custom_attr" => "custom_attr"
+            );
+
+            $product_extra_fields = func_query_column("
+                SELECT $sql_tbl[extra_fields].service_name 
+                FROM ($sql_tbl[extra_fields])
+                ORDER BY orderby; 
+            ");
+
+            foreach ($product_extra_fields as $k => $v) {
+                if (in_array($v, $default_additional_attributes)) {
+                    $additional_attributes[$k] = $v;
+                }
+            }
+        }
+
+        $file_header = "title\tdescription\tlink\timage_link\tid\tprice\tcurrency\tpayment_accepted\tpayment_notes\tquantity\tweight\texpiration_date\tbrand\tcondition\tproduct_type";
+
+        if (isset($additional_attributes) && is_array($additional_attributes)) {
+            foreach ($additional_attributes as $k=>$v) {
+                $file_header .= "\t$v";
+            }
+        }
+
+        fputs($fp, $file_header."\n");
 
         $where = '';
         $fields = '';
@@ -222,6 +259,21 @@
                 $product_url = $http_location.constant('DIR_CUSTOMER').'/'.func_get_resource_url('product', $product['productid'], '', false);
             }
 
+            $product_additional_attributes = "";
+            if(!empty($active_modules["Extra_Fields"])) {
+                $pid = $product['productid'];
+                $additional_attributes_cond = "'".implode("','",$additional_attributes)."'";
+                $product_additional_attributes = func_query_column("
+                    SELECT $sql_tbl[extra_field_values].value 
+                    FROM ($sql_tbl[extra_fields]) 
+                    LEFT JOIN $sql_tbl[extra_field_values] ON $sql_tbl[extra_fields].fieldid = $sql_tbl[extra_field_values].fieldid 
+                    AND $sql_tbl[extra_field_values].productid = '$pid' 
+                    WHERE $sql_tbl[extra_fields].service_name IN ($additional_attributes_cond)
+                    ORDER BY $sql_tbl[extra_fields].orderby;
+                ");
+                $product_additional_attributes = implode("\t",$product_additional_attributes);
+            }
+
             // Post string
             $post = func_froogle_convert($product['product'], 80)."\t".
                 func_froogle_convert($product['descr'], 65536)."\t".
@@ -237,7 +289,8 @@
                 date("Y-m-d", XC_TIME+(empty($config['Froogle']['froogle_expiration_date']) ? 0.5 : $config['Froogle']['froogle_expiration_date'])*86400)."\t".
                 func_froogle_convert($product['manufacturer'], 256)."\t".
                 "new\t".
-                (!empty($cats) ? $cats : '');
+                (!empty($cats) ? $cats : '').
+                (!empty($product_additional_attributes) ? "\t".$product_additional_attributes : '');
 
             fputs($fp, $post."\n");
             $cnt++;
